% $Id: DropboxTest.oz,v 1.3 2011/11/21 03:22:59 leavens Exp leavens $
\insert 'Dropbox.oz'
\insert 'TestingNoStop.oz'
declare
% Two set helpers for testing, which you don't have to implement
fun {SubsetOf LS1 LS2}
   {FoldR LS1 fun {$ Atm Res} {Member Atm LS2} andthen Res end true}
end
fun {EqualAsSets LS1 LS2} {SubsetOf LS1 LS2} andthen {SubsetOf LS2 LS1} end

{StartTesting 'DropboxTest $Revision: 1.3 $'}
Books = {NewDropbox}
Languages = {NewDropbox}
{Test {DBNames Books} '==' nil}
{DBDeposit Books secret [studying helps]}
{Test {DBNames Books} '==' [secret]}
{Test {DBNames Languages} '==' nil}
{Test {DBFetch Books secret} '==' [studying helps]}
{DBDeposit Books tale_of_two_cities
 [it was the best 'of' times it was the worst 'of' times]}
{Test {EqualAsSets {DBNames Books} [tale_of_two_cities secret]} '==' true}
{Test {DBFetch Books secret} '==' [studying helps]}
{Test {DBFetch Books tale_of_two_cities}
 '==' [it was the best 'of' times it was the worst 'of' times]}
{DBDelete Books secret}
{DBDeposit Books moby_dick [call me ishmael]}
{DBDeposit Books pride_and_prejudice
 [it is a truth universally acknowledged]}
{Test {EqualAsSets {DBNames Books}
       [moby_dick pride_and_prejudice tale_of_two_cities]} '==' true}
{Test {DBFetch Books tale_of_two_cities}
 '==' [it was the best 'of' times it was the worst 'of' times]}
{Test {DBFetch Books moby_dick} '==' [call me ishmael]}
{Test {DBFetch Books pride_and_prejudice}
 '==' [it is a truth universally acknowledged]}
{DBDeposit Languages french 7#sept}
{DBDeposit Languages spanish 6#seis}
{Test {EqualAsSets {DBNames Languages} [french spanish]} '==' true}
{Test {DBFetch Languages french} '==' 7#sept}
{DBDeposit Languages danish  5#fem}
{DBDeposit Languages catalan 4#cuatro}
{DBDeposit Languages irish 3#tri}
{Test {EqualAsSets {DBNames Languages} [irish catalan danish spanish french]}
 '==' true}
{Test {DBFetch Languages danish} '==' 5#fem}
{Test {DBFetch Languages irish} '==' 3#tri}
{DBDelete Languages danish}
{Test {EqualAsSets {DBNames Languages} [irish catalan spanish french]}
 '==' true}
{Test {DBFetch Languages catalan} '==' 4#cuatro}
{DoneTesting}
